diff --git a/RELEASE-NOTES-next b/RELEASE-NOTES-next
index 8797bc932..892c760a3 100644
--- a/RELEASE-NOTES-next
+++ b/RELEASE-NOTES-next
@@ -15,6 +15,8 @@ strongly encouraged to upgrade.
   • i3-nagbar: add option to position on primary monitor
   • alternate focusing tab/stack children-parent containers by clicking on their titlebars
   • i3bar: use first bar config by default
+  • i3-dump-log -f now uses UNIX sockets instead of pthreads. The UNIX socket approach
+    should be more reliable and also more portable.
 
  ┌────────────────────────────┐
  │ Bugfixes                   │
diff --git a/i3-dump-log/main.c b/i3-dump-log/main.c
index b11fdf827..0ce222647 100644
--- a/i3-dump-log/main.c
+++ b/i3-dump-log/main.c
@@ -258,11 +258,10 @@ int main(int argc, char *argv[]) {
             err(EXIT_FAILURE, "read(log-stream-socket):");
         }
         if (n == 0) {
-            // TODO: reconnect when i3 restarts, handle transient failures
-            exit(0);  /* i3 closed the socket */
+            exit(0); /* i3 closed the socket */
         }
         buf[n] = '\0';
-        write(STDOUT_FILENO, buf, n);
+        swrite(STDOUT_FILENO, buf, n);
     }
 
 #endif
diff --git a/include/configuration.h b/include/configuration.h
index eaf718291..11cdde0dd 100644
--- a/include/configuration.h
+++ b/include/configuration.h
@@ -93,7 +93,6 @@ struct Config {
     i3Font font;
 
     char *ipc_socket_path;
-    char *log_stream_socket_path;
     char *restart_state_path;
 
     layout_t default_layout;
diff --git a/libi3/create_socket.c b/libi3/create_socket.c
index 7954fe96a..4b93ff2da 100644
--- a/libi3/create_socket.c
+++ b/libi3/create_socket.c
@@ -25,8 +25,6 @@
  *
  */
 int create_socket(const char *filename, char **out_socketpath) {
-    int sockfd;
-
     char *resolved = resolve_tilde(filename);
     DLOG("Creating UNIX socket at %s\n", resolved);
     char *copy = sstrdup(resolved);
diff --git a/src/commands.c b/src/commands.c
index 8e8aece9e..cd9fb6fd1 100644
--- a/src/commands.c
+++ b/src/commands.c
@@ -1661,6 +1661,9 @@ void cmd_restart(I3_CMD) {
     }
     ipc_shutdown(SHUTDOWN_REASON_RESTART, exempt_fd);
     unlink(config.ipc_socket_path);
+    if (current_log_stream_socket_path != NULL) {
+        unlink(current_log_stream_socket_path);
+    }
     /* We need to call this manually since atexit handlers don’t get called
      * when exec()ing */
     purge_zerobyte_logfile();
diff --git a/src/ipc.c b/src/ipc.c
index 862e748e1..d69ecb6ec 100644
--- a/src/ipc.c
+++ b/src/ipc.c
@@ -1507,15 +1507,6 @@ ipc_client *ipc_new_client_on_fd(EV_P_ int fd) {
     return client;
 }
 
-/*
- * Creates the UNIX domain socket at the given path, sets it to non-blocking
- * mode, bind()s and listen()s on it.
- *
- */
-int ipc_create_socket(const char *filename) {
-    return create_socket(filename, &current_socketpath);
-}
-
 /*
  * Generates a json workspace event. Returns a dynamically allocated yajl
  * generator. Free with yajl_gen_free().
diff --git a/src/log.c b/src/log.c
index 03533210a..183bb8e63 100644
--- a/src/log.c
+++ b/src/log.c
@@ -375,14 +375,6 @@ void purge_zerobyte_logfile(void) {
 
 char *current_log_stream_socket_path = NULL;
 
-/*
- * Creates a UNIX socket for streaming log entries (i3-dump-log -f)
- *
- */
-int log_create_socket(const char *socket_path) {
-    return create_socket(socket_path, &current_log_stream_socket_path);
-}
-
 /*
  * Handler for activity on the listening socket, meaning that a new client
  * has just connected and we should accept() them. Sets up the event handler
@@ -414,11 +406,17 @@ void log_new_client(EV_P_ struct ev_io *w, int revents) {
 }
 
 void log_broadcast_to_clients(const char *message, size_t len) {
-    log_client *current;
-    TAILQ_FOREACH (current, &log_clients, clients) {
-        // TODO: In case slow connections turn out to be a problem here
-        // (unlikely as long as i3-dump-log is the only consumer), introduce
-        // buffering, similar to the IPC interface.
-        write(current->fd, message, len);
+    log_client *current = TAILQ_FIRST(&log_clients);
+    while (current != TAILQ_END(&log_clients)) {
+        /* XXX: In case slow connections turn out to be a problem here
+         * (unlikely as long as i3-dump-log is the only consumer), introduce
+         * buffering, similar to the IPC interface. */
+        ssize_t n = writeall(current->fd, message, len);
+        log_client *previous = current;
+        current = TAILQ_NEXT(current, clients);
+        if (n < 0) {
+            TAILQ_REMOVE(&log_clients, previous, clients);
+            free(previous);
+        }
     }
 }
diff --git a/src/main.c b/src/main.c
index b760b3cc4..54b38f449 100644
--- a/src/main.c
+++ b/src/main.c
@@ -181,6 +181,9 @@ static void i3_exit(void) {
     }
     ipc_shutdown(SHUTDOWN_REASON_EXIT, -1);
     unlink(config.ipc_socket_path);
+    if (current_log_stream_socket_path != NULL) {
+        unlink(current_log_stream_socket_path);
+    }
     xcb_disconnect(conn);
 
     /* If a nagbar is active, kill it */
@@ -634,11 +637,6 @@ int main(int argc, char *argv[]) {
             config.ipc_socket_path = sstrdup(config.ipc_socket_path);
     }
 
-    if (config.log_stream_socket_path == NULL) {
-        /* Chose a file name in /tmp/ based on the PID */
-        config.log_stream_socket_path = get_process_filename("log-stream-socket");
-    }
-
     if (config.force_xinerama) {
         force_xinerama = true;
     }
@@ -859,7 +857,10 @@ int main(int argc, char *argv[]) {
         ev_io_start(main_loop, ipc_io);
     }
 
-    int log_socket = create_socket(config.log_stream_socket_path, &current_log_stream_socket_path);
+    /* Chose a file name in /tmp/ based on the PID */
+    char *log_stream_socket_path = get_process_filename("log-stream-socket");
+    int log_socket = create_socket(log_stream_socket_path, &current_log_stream_socket_path);
+    free(log_stream_socket_path);
     if (log_socket == -1) {
         ELOG("Could not create the log socket, i3-dump-log -f will not work\n");
     } else {
